//+------------------------------------------------------------------+
//|                                                ProfitCounter.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_style1 STYLE_SOLID
#property indicator_color1 Silver
#property indicator_width1 3

//---- indicator buffers
double ind_buffer1[];

extern int kaoposition  = 5;
extern int fontposition = 13;
extern int kaowidth     = 3;
extern int fontsize     = 10;
extern int save         = 10;

double AC;
int n;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,3);
   SetIndexBuffer(0,ind_buffer1);
   SetIndexArrow(0,75);
   
   if(kaoposition <= 0) kaoposition = 1;
   if(fontposition <= 0) fontposition = 1;
  
   AC=AccountBalance();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i=0;i<=save;i++)
   {
      if(ObjectFind("kao" + i)!=-1)
      {
         ObjectDelete("kao" + i);
         ObjectDelete("per" + i);
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----

    double min = WindowPriceMin();
    double max = WindowPriceMax();
    
   for (int i = WindowFirstVisibleBar() - WindowBarsPerChart(); i < WindowFirstVisibleBar(); i++) 
   {
      ind_buffer1[i+1]=EMPTY_VALUE;
   }
   ind_buffer1[ WindowFirstVisibleBar()-1]= max - (max - min)/100 * kaoposition;

   
   for( i=0;i<=save;i++)
   {
      if(ObjectFind("kao" + i)!=-1)
      {
         ObjectMove("kao" + i,0,ObjectGet("kao" + i,OBJPROP_TIME1),max - (max - min)/100 * kaoposition);
         ObjectMove("per" + i,0,ObjectGet("per" + i,OBJPROP_TIME1),max - (max - min)/100 * fontposition);
      }
   }
      
   string profit;
   if(AccountBalance()>AC)
   {
      profit="+" + DoubleToStr((AccountBalance()/AC - 1)*100,2)+"%";
      ObjectDelete("kao" + n);
      ObjectDelete("per" + n);
      ObjectCreate("kao" + n, OBJ_ARROW, 0, Time[0],max - (max - min)/100 * kaoposition);
      ObjectSet("kao" + n,OBJPROP_ARROWCODE,74);
      ObjectSet("kao" + n,OBJPROP_COLOR,Yellow);
      ObjectSet("kao" + n,OBJPROP_WIDTH,kaowidth);
      ObjectCreate("per" + n, OBJ_TEXT, 0, Time[0],max - (max - min)/100 * fontposition);
      ObjectSetText("per" + n,profit,fontsize, "Arial",White);
      AC=AccountBalance();
      n++;
   }
   if(AccountBalance()<AC)
   {
      profit=DoubleToStr((AccountBalance()/AC - 1)*100,2)+"%";
      ObjectDelete("kao" + n);
      ObjectDelete("per" + n);
      ObjectCreate("kao" + n, OBJ_ARROW, 0, Time[0],max - (max - min)/100 * kaoposition);
      ObjectSet("kao" + n,OBJPROP_ARROWCODE,76);
      ObjectSet("kao" + n,OBJPROP_COLOR,Red);
      ObjectSet("kao" + n,OBJPROP_WIDTH,kaowidth);
      ObjectCreate("per" + n, OBJ_TEXT, 0, Time[0],max - (max - min)/100 * fontposition);
      ObjectSetText("per" + n,profit,fontsize, "Arial",White);
      AC=AccountBalance();
      n++;
   }   
   if(n>save) n=0;
//----
   return(0);
  }
//+------------------------------------------------------------------+